/**
 * The code in this file is adapted from ngrx/signals
 *
 * ngrx is an open-source project licensed under the MIT license.
 *
 * For more information about the original code, see
 * https://github.com/ngrx/platform
 */
import { Signal as NgSignal } from '@angular/core';
import { IsKnownRecord } from './tsHelpers';
export interface Signal<T> extends NgSignal<T> {
    name: unknown;
    length: unknown;
}
export type DeepSignal<T> = Signal<T> & Readonly<Required<{
    [K in keyof T]: IsKnownRecord<T[K]> extends true ? DeepSignal<T[K]> : Signal<T[K]>;
}>>;
export declare function toDeepSignal<T>(signal: Signal<T>): DeepSignal<T>;
